diff --git a/pdns/distributor.hh b/pdns/distributor.hh
index d716869..f958ff3 100644
--- a/pdns/distributor.hh
+++ b/pdns/distributor.hh
@@ -259,7 +259,16 @@ template<class Answer, class Question, class Backend>void *MultiThreadDistributo
       AnswerData<Answer> AD;
       AD.A=a;
 
-      QD.callback(AD);
+      try {
+        QD.callback(AD);
+      }
+      catch(std::exception& e)
+      {
+        L<<Logger::Error<<"Error in callback (while sending reply): "<<e.what()<<endl;
+      }
+      catch(...) {
+        L<<Logger::Error<<"Unknown callback (sending reply) error"<<endl;
+      }
     }
     
     delete b;
@@ -299,7 +308,16 @@ template<class Answer, class Question, class Backend>int SingleThreadDistributor
   }
   AnswerData<Answer> AD;
   AD.A=a;
-  callback(AD);
+  try {
+    callback(AD);
+  }
+  catch(std::exception& e)
+  {
+    L<<Logger::Error<<"Error in callback (while sending reply): "<<e.what()<<endl;
+  }
+  catch(...) {
+    L<<Logger::Error<<"Unknown callback (sending reply) error"<<endl;
+  }
   return 0;
 }
 
diff --git a/pdns/distributor.hh b/pdns/distributor.hh
index f958ff3..c6b3ae6 100644
--- a/pdns/distributor.hh
+++ b/pdns/distributor.hh
@@ -265,9 +265,11 @@ template<class Answer, class Question, class Backend>void *MultiThreadDistributo
       catch(std::exception& e)
       {
         L<<Logger::Error<<"Error in callback (while sending reply): "<<e.what()<<endl;
+        delete AD.A;
       }
       catch(...) {
         L<<Logger::Error<<"Unknown callback (sending reply) error"<<endl;
+        delete AD.A;
       }
     }
     
@@ -314,9 +316,11 @@ template<class Answer, class Question, class Backend>int SingleThreadDistributor
   catch(std::exception& e)
   {
     L<<Logger::Error<<"Error in callback (while sending reply): "<<e.what()<<endl;
+    delete AD.A;
   }
   catch(...) {
     L<<Logger::Error<<"Unknown callback (sending reply) error"<<endl;
+    delete AD.A;
   }
   return 0;
 }
-- 
2.5.0

